﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AudioLoopMaker
{
    public partial class ColorSelector : UserControl
    {
        public ColorSelector()
        {
            InitializeComponent();
            colorDialog.AllowFullOpen = true;
            colorDialog.FullOpen = true;
        }

        [Localizable(true)]
        public string LabelText
        {
            get => label.Text;
            set => label.Text = value;
        }

        public Color Color
        {
            get => colorDialog.Color;
            set
            {
                colorDialog.Color = value;
                pictureBox.Invalidate();
            }
        }

        private void pictureBox_Click(object sender, EventArgs e)
        {
            if(colorDialog.ShowDialog() == DialogResult.OK)
            {
                Color = colorDialog.Color;
            }
        }

        private void pictureBox_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.Clear(Color);
        }
    }
}
