﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace BveTool
{
    public partial class AboutForm : Form
    {
        public AboutForm()
        {
            InitializeComponent();
        }

        public void ShowVersionInfo(Control owner)
        {
            tabPageThirdPartySoftware.Controls.Remove(versionLabel);
            Controls.Add(versionLabel);

            this.Size = new Size(320, 160);
            titleLabel.Size = new Size(280, 23);
            versionLabel.Size = new Size(280, 23);
            copyrightLabel.Size = new Size(280, 23);

            titleLabel.Location = new Point(12, 9);
            versionLabel.Location = new Point(12, 35);
            copyrightLabel.Location = new Point(12, 61);
            button.Location = new Point(217, 87);

            titleLabel.TextAlign = ContentAlignment.MiddleCenter;
            versionLabel.TextAlign = ContentAlignment.MiddleCenter;
            copyrightLabel.TextAlign = ContentAlignment.MiddleCenter;
            versionLabel.AutoSize = false;
            tabControl.Visible = false;

            System.Reflection.AssemblyTitleAttribute asmTitle =
                (System.Reflection.AssemblyTitleAttribute)
                Attribute.GetCustomAttribute(
                System.Reflection.Assembly.GetExecutingAssembly(),
                typeof(System.Reflection.AssemblyTitleAttribute));

            System.Reflection.AssemblyCopyrightAttribute asmCopyRight =
                (System.Reflection.AssemblyCopyrightAttribute)
                Attribute.GetCustomAttribute(
                System.Reflection.Assembly.GetExecutingAssembly(),
                typeof(System.Reflection.AssemblyCopyrightAttribute));

            titleLabel.Text = asmTitle.Title;
            versionLabel.Text = string.Format("Version {0}", Application.ProductVersion);
            copyrightLabel.Text = asmCopyRight.Copyright;

            this.ShowDialog(owner);
        }


        public void ShowVersionInfoWithLicense(Control owner, string thirdPartySoftware)
        {
            ShowVersionInfoWithLicense(owner, string.Empty, thirdPartySoftware);
        }

        public void ShowVersionInfoWithLicense(Control owner, string license, string thirdPartySoftware)
        {
            System.Reflection.AssemblyTitleAttribute asmTitle =
                (System.Reflection.AssemblyTitleAttribute)
                Attribute.GetCustomAttribute(
                System.Reflection.Assembly.GetExecutingAssembly(),
                typeof(System.Reflection.AssemblyTitleAttribute));

            System.Reflection.AssemblyCopyrightAttribute asmCopyRight =
                (System.Reflection.AssemblyCopyrightAttribute)
                Attribute.GetCustomAttribute(
                System.Reflection.Assembly.GetExecutingAssembly(),
                typeof(System.Reflection.AssemblyCopyrightAttribute));

            titleLabel.Text = string.Format("{0}, Version {1}", asmTitle.Title, Application.ProductVersion);
            copyrightLabel.Text = asmCopyRight.Copyright;

            if (!string.IsNullOrEmpty(license))
            {
                textBoxLicense.Text = license;
                textBoxLicense.Select(0, 0);
            }
            else
            {
                tabControl.TabPages.Remove(tabPageLicense);
            }

            if (!string.IsNullOrEmpty(thirdPartySoftware))
            {
                textBoxThirdPartySoftware.Text = thirdPartySoftware;
                textBoxThirdPartySoftware.Select(0, 0);
            }
            else
            {
                tabControl.TabPages.Remove(tabPageThirdPartySoftware);
            }

            this.ShowDialog(owner);
        }

        private void button_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
