﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Bvews.Common
{
    static class AppDataPath
    {
        public static string CurrentVersion
        {
            get
            {
#if PORTABLE
                return Application.StartupPath;
#else
                // "InvalidDeploymentException" is thrown if "Just My Code" is disabled.
                // http://germanylandofinnovation.com/questions/15182/anwendungsidentitat-nicht-festgelegt-ausnahme
                return Application.UserAppDataPath;
#endif
            }
        }

        public static string PreviousVersion
        {
            get
            {
#if PORTABLE
                return Application.StartupPath;
#else
                var versions = Directory.GetDirectories(Path.Combine(CurrentVersion, "..\\"))
                    .Select(d => Path.GetFileName(d)).ToList();
                versions.Sort();
                var currentVersion = Path.GetFileName(CurrentVersion);
                var index = versions.IndexOf(currentVersion);
                if (index <= 0)
                {
                    return CurrentVersion;
                }
                else
                {
                    var directoryInfo = new DirectoryInfo(Path.Combine(CurrentVersion, "..\\"));
                    return Path.Combine(directoryInfo.FullName, versions[index - 1]);
                }
#endif
            }
        }
    }
}
