﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;
using System.Windows.Forms;

namespace Bvews.Common
{
    static class HelpManager
    {
        public static void ShowHelp(string downloadUrl)
        {
            var isJapanese = Thread.CurrentThread.CurrentUICulture.Name.StartsWith("ja");
            var message = isJapanese ? "ヘルプファイルが見つかりません。ヘルプが記載されているダウンロードページを表示しますか？"
                : "The help file was not found. Do you want to browse the download page containing help?";
            var caption = isJapanese ? "確認" : "Confirm";

            string path = Path.Combine(Application.StartupPath, "help");
            path = Path.Combine(path, isJapanese ? "ja" : "en");
            path = Path.Combine(path, "index.html");

            if(File.Exists(path))
            {
                System.Diagnostics.Process.Start(path);
            }
            else
            {
                if (MessageBox.Show(message, caption, MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    System.Diagnostics.Process.Start(downloadUrl);
                }
            }
        }
    }
}
