﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace Bvews.Common.UpdateChecker
{
    public class UpdateInfoData
    {
        public UpdateInfoData()
        {
            Version = string.Empty;
            LatestAppVersion = string.Empty;
            ChangelogJapanese = new List<string>();
            ChangelogEnglish = new List<string>();
        }

        public static UpdateInfoData Load(string path)
        {
            try
            {
                var serializer = new XmlSerializer(typeof(UpdateInfoData));
                using (var fs = new FileStream(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite))
                {
                    return Load(fs);
                }
            }
            catch (Exception)
            {
                throw;
            }
        }

        public static UpdateInfoData Load(Stream stream)
        {
            try
            {
                using (var sr = new StreamReader(stream))
                {
                    var serializer = new XmlSerializer(typeof(UpdateInfoData));
                    return (UpdateInfoData)serializer.Deserialize(sr);
                }
            }
            catch (Exception)
            {
                throw;
            }
        }

        public void Save(string path)
        {
            try
            {
                var serializer = new XmlSerializer(typeof(UpdateInfoData));
                using (var sw = new StreamWriter(path))
                {
                    serializer.Serialize(sw, this);
                }
            }
            catch
            {
            }
        }

        public string Version { get; set; }
        public string LatestAppVersion { get; set; }
        public List<string> ChangelogJapanese { get; set; }
        public List<string> ChangelogEnglish { get; set; }
    }
}
