﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing;

namespace AudioLoopMaker
{
    class NumericUpDownPosition : NumericUpDown
    {
        private bool bypassEvent = false;
        EventHandler eventHandler = null;
        Point? mouseDownLocation = null;
        decimal mouseDownValue;

        public event EventHandler ValueChanged
        {
            add
            {
                eventHandler += value;
                base.ValueChanged += value;
            }
            remove
            {
                eventHandler -= value;
                base.ValueChanged -= value;
            }
        }

        public decimal Value
        {
            get
            {
                return base.Value;
            }
            set
            {
                //base.ValueChanged -= eventHandler;

                if (value > base.Maximum)
                {
                    base.Value = base.Maximum;
                }
                else if (value < base.Minimum)
                {
                    base.Value = base.Minimum;
                }
                else
                {
                    base.Value = value;
                }

                //base.ValueChanged += eventHandler;
            }
        }

        protected override void OnMouseDown(MouseEventArgs e)
        {
            base.OnMouseDown(e);
            mouseDownLocation = e.Location;
            mouseDownValue = this.Value;
        }

        protected override void OnMouseMove(MouseEventArgs e)
        {
            base.OnMouseMove(e);
            if (mouseDownLocation != null)
            {
                this.Value = mouseDownValue + (decimal)(10 * (mouseDownLocation.Value.Y - e.Y));
            }
        }

        protected override void OnMouseUp(MouseEventArgs mevent)
        {
            base.OnMouseUp(mevent);
            mouseDownLocation = null;

            switch (mevent.Button)
            {
                case MouseButtons.XButton1:
                    this.Value -= 100;
                    break;
                case MouseButtons.XButton2:
                    this.Value += 100;
                    break;
            }
        }
    }
}
