﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AudioLoopMaker
{
    public partial class PreferencesForm : Form
    {
        public PreferencesForm()
        {
            InitializeComponent();
            
            checkBoxShowFileName.Checked = Settings.Instance.Preferences.ShowFileNameInTitle;
            textBoxSuffix.Text = Settings.Instance.Preferences.Suffix;
            checkBoxNotifyUpdate.Checked = Settings.Instance.Preferences.NotifyUpdate;
            SetColor();
        }

        private void SetColor()
        {
            var color = Settings.Instance.WaveViewOptions.Color;
            colorSelectorBackground.Color = color.Background;
            colorSelectorWaveform.Color = color.Waveform;
            colorSelectorWaveformDark.Color = color.WaveformDark;
            colorSelectorCursor.Color = color.Cursor;
            colorSelectorCenter.Color = color.CenterLine;
            colorSelectorStart.Color = color.SectionStart;
            colorSelectorEnd.Color = color.SectionEnd;
        }

        private void buttonInitialize_Click(object sender, EventArgs e)
        {
            colorSelectorBackground.Color = Color.FromArgb(8, 16, 32);
            colorSelectorWaveform.Color = Color.FromArgb(0, 255, 64);
            colorSelectorWaveformDark.Color = Color.FromArgb(0, 192, 32);
            colorSelectorCursor.Color = Color.FromArgb(255, 255, 255);
            colorSelectorCenter.Color = Color.FromArgb(0, 0, 192);
            colorSelectorStart.Color = Color.FromArgb(255, 0, 0);
            colorSelectorEnd.Color = Color.FromArgb(128, 0, 255);
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            Settings.Instance.Preferences.ShowFileNameInTitle = checkBoxShowFileName.Checked;
            Settings.Instance.Preferences.Suffix = textBoxSuffix.Text;
            Settings.Instance.Preferences.NotifyUpdate = checkBoxNotifyUpdate.Checked;

            var color = Settings.Instance.WaveViewOptions.Color;
            color.Background = colorSelectorBackground.Color;
            color.Waveform = colorSelectorWaveform.Color;
            color.WaveformDark = colorSelectorWaveformDark.Color;
            color.Cursor = colorSelectorCursor.Color;
            color.CenterLine = colorSelectorCenter.Color;
            color.SectionStart = colorSelectorStart.Color;
            color.SectionEnd = colorSelectorEnd.Color;

            DialogResult = DialogResult.OK;
            Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }
    }
}
