﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Bvews.Wave
{
    public class RiffChunk
    {
        public byte[] Id { get; set; }
        public uint Size { get; set; }
        public long Position { get; set; }

        public byte[] FormType { get; set; }
        RiffChunk[] Chunks { get; set; }

        public bool IsIdEqual(string comparison)
        {
            return IsEqual(Id, comparison);
        }

        public bool IsFormTypeEqual(string comparison)
        {
            return IsEqual(FormType, comparison);
        }

        public void SetId(string id)
        {
            Id = ToBytes(id);
        }

        public void SetFormType(string formType)
        {
            FormType = ToBytes(formType);
        }

        private static bool IsEqual(byte[] a, string b)
        {
            byte[] bytesData = Encoding.UTF8.GetBytes(b);
            if (a == null || a.Length != 4 || bytesData.Length != 4)
            {
                return false;
            }
            for (int i = 0; i < 4; i++)
            {
                if (a[i] != bytesData[i])
                {
                    return false;
                }
            }
            return true;
        }

        private static byte[] ToBytes(string text)
        {
            if(text.Length != 4)
            {
                throw new ArgumentException();
            }
            else
            {
                return System.Text.Encoding.UTF8.GetBytes(text);
            }
        }
    }
}
