﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AudioLoopMaker
{
    class WaveStreamOrdinaryLoop : WaveStream
    {
        public WaveStreamOrdinaryLoop(float[][] buffers)
            : base(buffers) { }
        
        protected override float[][] Read(float[][] resultBuffers, int length)
        {
            for (int i = 0; i < length; i++)
            {
                if (bufferPosition >= end || bufferPosition < start)
                {
                    bufferPosition = start;
                }

                for (int j = 0; j < channels; j++)
                {
                    resultBuffers[j][i] = buffers[j][bufferPosition];
                }
                
                bufferPosition++;                
            }

            return resultBuffers;
        }

        public override float[][] Flush()
        {
            var length = end - start;
            var result = new float[channels][];

            for (int i = 0; i < channels; i++)
            {
                result[i] = new float[length];
                Array.Copy(buffers[i], start, result[i], 0, length);
            }

            return result;
        }
    }
}
