﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace AudioLoopMaker
{
    public class WaveViewOptions
    {
        public WaveViewOptions()
        {
            Color = new WaveViewColor()
            {
                Background = System.Drawing.Color.FromArgb(8, 16, 32),
                Waveform = System.Drawing.Color.FromArgb(0, 255, 64),
                WaveformDark = System.Drawing.Color.FromArgb(0, 192, 32),
                WaveformGray = System.Drawing.Color.FromArgb(128, 128, 128),
                WaveformGrayDark = System.Drawing.Color.FromArgb(64, 64, 64),
                Cursor = System.Drawing.Color.FromArgb(255, 255, 255),
                SectionStart = System.Drawing.Color.FromArgb(255, 0, 0),
                SectionEnd = System.Drawing.Color.FromArgb(128, 0, 255),
                CenterLine = System.Drawing.Color.FromArgb(0, 0, 192)
            };
            GripSize = new System.Drawing.Size(10, 10);
            WaveformHeightRate = 0.8f;
        }

        public WaveViewColor Color { get; set; }
        public System.Drawing.Size GripSize { get; set; }
        public float WaveformHeightRate { get; set; }

        public class WaveViewColor
        {
            [XmlIgnore]
            public System.Drawing.Color Background { get; set; }
            [XmlIgnore]
            public System.Drawing.Color Waveform { get; set; }
            [XmlIgnore]
            public System.Drawing.Color WaveformDark { get; set; }
            [XmlIgnore]
            public System.Drawing.Color WaveformGray { get; set; }
            [XmlIgnore]
            public System.Drawing.Color WaveformGrayDark { get; set; }
            [XmlIgnore]
            public System.Drawing.Color Cursor { get; set; }
            [XmlIgnore]
            public System.Drawing.Color SectionStart { get; set; }
            [XmlIgnore]
            public System.Drawing.Color SectionEnd { get; set; }
            [XmlIgnore]
            public System.Drawing.Color CenterLine { get; set; }

            public string BackgroundHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(Background); }
                set { Background = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string WaveformHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(Waveform); }
                set { Waveform = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string WaveformDarkHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(WaveformDark); }
                set { WaveformDark = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string WaveformGrayHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(WaveformGray); }
                set { WaveformGray = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string WaveformGrayDarkHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(WaveformGrayDark); }
                set { WaveformGrayDark = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string CursorHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(Cursor); }
                set { Cursor = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string SectionBeginHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(SectionStart); }
                set { SectionStart = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string SectionEndHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(SectionEnd); }
                set { SectionEnd = System.Drawing.ColorTranslator.FromHtml(value); }
            }
            public string CenterLineHtml
            {
                get { return System.Drawing.ColorTranslator.ToHtml(CenterLine); }
                set { CenterLine = System.Drawing.ColorTranslator.FromHtml(value); }
            }
        }
    }
}
